// Electro

#include "electro.h"

#define ballnum 6

#define pointnum (24 * 24 * 24)

float *ban;
float *bx;
float *by;
float *bz;

float *elepx;
float *elepy;
float *elepz;
float *elepr;
float *elepg;
float *elepb;
float *elealpha;

void initelectro() {
	int i,x,y;
	int gi = 0;
	float gx,gy;
	ban = new float[ballnum];
	bx = new float[ballnum];
	by = new float[ballnum];
	bz = new float[ballnum];
	elepx = new float[pointnum];
	elepy = new float[pointnum];
	elepz = new float[pointnum];
	elepr = new float[pointnum];
	elepg = new float[pointnum];
	elepb = new float[pointnum];
	elealpha = new float[pointnum];
	srand(16);
	for(i = 0; i < ballnum; i++) {
		do {
			ban[i] = randfloat() * 2.0 - 1.0;// * 3.141592;
		} while(ban[i] > -.3 && ban[i] < .3);
		//ban[i] = (float) i / (float) ballnum * 2.0 * 3.141592;
	}
}

void freeelectro() {
	delete [] ban;
	delete [] bx;
	delete [] by;
	delete [] bz;
	delete [] elepx;
	delete [] elepy;
	delete [] elepz;
	delete [] elepr;
	delete [] elepg;
	delete [] elepb;
	delete [] elealpha;
}

void electro(float time) {
	float et = time * 20.0;//timer_gettime();
	const float ean = (et + 20.0) * .4;
	int i;
	int x,y,z;
	int pi = 0;
	float ealpha = 1.0;
	if(time < .05) ealpha = time * 20.0;
	if(time > .95) ealpha -= (time - .95) * 20.0;
	float ox,oy,oz;
	float tx,ty,tz,ta,ta2;
	float xd,yd,zd,d;
	float r,g,b;
	glLoadIdentity();
	glDisable(GL_DEPTH_TEST);
	glBlendFunc(GL_SRC_ALPHA,GL_ONE);//_MINUS_SRC_ALPHA);
	glEnable(GL_BLEND);
	glTranslatef(0,0,sin(et * .2) * .5 - 2.0);
	glRotatef(sin(et * .1) * 10.0,1.0,0,0);
	glRotatef(et * 4.0,0,1.0,0);
	glRotatef(sin(et * .05) * 10.0,0,0,1.0);
	glColor4f(1.0,1.0,1.0,.2 * ealpha);
	glTranslatef(0,1.8,0);

	if((time >= 0.247) && (time < 0.279))
	{
		glRotatef(90*(time-0.247)/(0.279-0.247), 0.2, 5.0, 0.2);
	}
	else if (time >= 0.279)
	{
		glRotatef(90, 0.2, 5.0, 0.2);
	}

	if((time >= 0.716) && (time < 0.748))
	{
		glRotatef(90*(time-0.716)/(0.748-0.716), 0.2, 5.0, 0.2);
	}
	else if (time >= 0.748)
	{
		glRotatef(90, 0.2, 5.0, 0.2);
	}

	if((time >= 0.946) && (time < 0.978))
	{
		glRotatef(90*(time-0.946)/(0.978-0.946), 5.0, 0.0, 0.2);
	}
	else if (time >= 0.978)
	{
		glRotatef(90, 0.5, 0.0, 0.2);
	}

	glPushMatrix();
	if((time >= 0.477) && (time < 0.509))
	{
		glRotatef(90*(time-0.477)/(0.509-0.477),5.0, 0.0, 0.0);
	}
	else if (time >= 0.509)
	{
		glRotatef(90, 5.0, 0.0, 0.0);
	}

	glBegin(GL_LINES);
	gridcube(6.0);
	glEnd();
	glPopMatrix();

	glTranslatef(0,-1.8,0);
	for(i = 0; i < ballnum; i++) {
		float tean = ean * ban[i];
		bx[i] = sin(tean) * .4;
		by[i] = cos(tean * .67) * .4;
		bz[i] = sin(tean * .43) * .4;
	}
	for(z = 0; z < 24; z++) {
		oz = (float) z / 23.0 - .5;
		for(y = 0; y < 24; y++) {
			oy = (float) y / 23.0 - .5;
			for(x = 0; x < 24; x++) {
				ox = (float) x / 23.0 - .5;
				tx = ox;
				ty = oy;
				tz = oz;
				ta = 0;
				for(i = 0; i < ballnum; i++) {
					xd = (bx[i] - ox) * 7.0;
					yd = (by[i] - oy) * 7.0;
					zd = (bz[i] - oz) * 7.0;
					d = sqrt(xd * xd + yd * yd + zd * zd);
					if(d < 1.0) {
						xd /= d;
						yd /= d;
						zd /= d;
						d = 1.0 - d;
						ta += d;// * .75;
						d *= .1;
						tx -= xd * d;
						ty -= yd * d;
						tz -= zd * d;
					}
				}
				if(ta > 1.0) ta = 1.0;
				ta2 = 1.0 - ta;
				elepx[pi] = tx;
				elepy[pi] = ty;
				elepz[pi] = tz;
				elepr[pi] = ta * .2 + ta2;
				elepg[pi] = ta2;
				elepb[pi] = ta * .5 + ta2;
				elealpha[pi] = ta * ealpha;
				pi++;
			}
		}
	}
	glPointSize((float) getscrw() / 1024.0 * 7.0);
	glBegin(GL_POINTS);
	for(i = 0; i < pointnum; i++) {
		glColor4f(elepr[i],elepg[i],elepb[i],elealpha[i]);
		glVertex3f(elepx[i],elepy[i],elepz[i]);
	}
	glEnd();
	glPointSize((float) getscrw() / 1024.0 * 20.0);
	glBegin(GL_POINTS);
	for(i = 0; i < pointnum; i++) {
		glColor4f(elepr[i],elepg[i],elepb[i],elealpha[i] * .3);
		glVertex3f(elepx[i],elepy[i],elepz[i]);
	}
	glEnd();
}
