#include "filler.h"

static unsigned int noise[8];
static char noisetexture[640][480][3];

void filler_init(void)
{
	for(int i=0; i < 8; i++)
	{
		for(int y=0; y<640; y++)
		{
			for(int x=0; x<480; x++)
			{
				char color = rand()%128;
				noisetexture[y][x][0]=(char)color;
				noisetexture[y][x][1]=(char)color;
				noisetexture[y][x][2]=(char)color;
			}
		}

		glGenTextures(1, &noise[i]);

		glBindTexture(GL_TEXTURE_2D, noise[i]);

		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);

		gluBuild2DMipmaps(GL_TEXTURE_2D, GL_RGB, 640, 480, GL_RGB, GL_UNSIGNED_BYTE, noisetexture);
	}
}

static float noise_timer = 0.0f;
void filler_run(float time)
{
	glEnable(GL_TEXTURE_2D);
	float alpha = 1.0;
	if(time < .2) alpha = time * 5.0;
	if(time >= .95) alpha -= (time - .95) * 20.0;
	alpha *= .3;
	float alpha2 = alpha * .6;

	glEnable(GL_BLEND);
	glBindTexture(GL_TEXTURE_2D, noise[int(time*7560)&7]);
	glBlendFunc(GL_ONE, GL_ONE);

	glColor3f(alpha2,alpha2,alpha2);
	if (sound_isSync(SNARE))
	{
		noise_timer = timer_gettime() + 0.1f;
	}
	if (noise_timer > timer_gettime())
	{
		glColor3f(alpha,alpha,alpha);
	}

	perspective2DBegin(640,480);

	glBegin(GL_QUADS);
	glTexCoord2d(1,1);
	glVertex2f(640, 480);
	glTexCoord2d(0,1);
	glVertex2f(0, 480);
	glTexCoord2d(0,0);
	glVertex2f(0, 0);
	glTexCoord2d(1,0);
	glVertex2f(640, 0);
	glEnd();
	glColor3f(alpha,alpha,alpha);
	perspective2DEnd();
	glBindTexture(GL_TEXTURE_2D, 0);
	glDisable(GL_TEXTURE_2D);
	glDisable(GL_BLEND);
}
