// Iterator

#include "iterator.h"

#define maxiterator 2100
#define maxfloaters 1000

float *iteratorx;
float *iteratory;
float *iteratorz;

float *floaterx;
float *floatery;
float *floaterz;

void inititerator() {
	iteratorx = new float[maxiterator];
	iteratory = new float[maxiterator];
	iteratorz = new float[maxiterator];
	floaterx = new float[maxfloaters];
	floatery = new float[maxfloaters];
	floaterz = new float[maxfloaters];
	int i;
	float an2 = 0;
	srand(0);//setseed(-1);
	for(i = 0; i < maxfloaters; i++) {
		floaterx[i] = randfloat() * 50.0 - 25.0;
		floatery[i] = randfloat() * 50.0 - 25.0;
		floaterz[i] = randfloat() * 50.0 - 25.0;
	}
	for(i = 0; i < maxiterator; i++) {
		iteratorx[i] = sin(an2);
		iteratory[i] = sin(an2 * .67);
		iteratorz[i] = cos(an2 * .43);
		an2 += .04;
	}
}

void freeiterator() {
	delete [] iteratorx;
	delete [] iteratory;
	delete [] iteratorz;
	delete [] floaterx;
	delete [] floatery;
	delete [] floaterz;
}

static float sync_timer = 0.0f;
#define FLOATER_RAND_MAX 200
static int floater_rand[FLOATER_RAND_MAX];

void iterator(float time) {
	glPushMatrix();
	float alpha = 1.0;
	if(time > .95) alpha -= (time - .95) * 20.0;
	float iteratoran = time * 90.0;
	int i;
	float d = iteratoran * .5 - 6.0;
	if(d > 0) {
		d = 0;
	} else {
		d *= d * d;
	}
	glLoadIdentity();
	glFogf(GL_FOG_START,15.0);
	glFogf(GL_FOG_END,30.0);
	glEnable(GL_FOG);
	glDisable(GL_DEPTH_TEST);
	glBlendFunc(GL_SRC_ALPHA,GL_ONE);//_MINUS_SRC_ALPHA);
	glEnable(GL_BLEND);
	glTranslatef(-1.4,0,d - 5.0);
	glRotatef(iteratoran * 2.0,.34,.67,1.0);
	glColor4f(1.0,1.0,1.0,alpha);


	if (d == 0)
	{
		if (sound_isSync(LEAD))
		{
			sync_timer = timer_gettime() + 0.8f;
			for(i = 0; i < FLOATER_RAND_MAX; i++)
			{
				floater_rand[i] = rand()%maxfloaters;
			}
		}
		if (sync_timer > timer_gettime())
		{
			glPointSize(5.0*((sync_timer-timer_gettime())/0.8f));

			glBegin(GL_POINTS);
			for(i = 0; i < FLOATER_RAND_MAX; i++)
			{
				glVertex3f(floaterx[floater_rand[i]],floatery[floater_rand[i]],floaterz[floater_rand[i]]);
			}
			glEnd();
		}
	}

	glPointSize(2.0);
	glBegin(GL_POINTS);
	for(i = 0; i < maxfloaters; i++) {
		glVertex3f(floaterx[i],floatery[i],floaterz[i]);
	}
	glEnd();
	//int it = (int) (time * (float) maxiterator);
	int it = (int) (iteratoran * 24.0);
	if(it > maxiterator) it = maxiterator;
	glBegin(GL_LINES);
	for(i = 0; i < it; i++) {
		if(i > 0 && i & 1) {
			glVertex3f(iteratorx[i - 1],iteratory[i - 1],iteratorz[i - 1]);
			glVertex3f(iteratorx[i],iteratory[i],iteratorz[i]);
		}
	}
	glEnd();
	alpha *= .2;
	glBegin(GL_TRIANGLES);
	for(i = 0; i < it; i++) {
		if(i > 0) {
			glColor4f(.2,0,.5,0);
			glVertex3f(iteratorx[i - 1],iteratory[i - 1],iteratorz[i - 1]);
			glVertex3f(iteratorx[i],iteratory[i],iteratorz[i]);
			glColor4f(.2,0,.5,alpha);
			glVertex3f(0,0,0);
		}
	}
	glEnd();
	glDisable(GL_FOG);
	glEnable(GL_DEPTH_TEST);

	glPopMatrix();
	glLoadIdentity();
	glTranslatef(0,0,-1.0);
	if((time >= 0.3) && (time < 0.5))
	{
		if(time>=0.3 && time<0.4)
		{
			glColor4f(.2,0,.5,((time-0.3)/(0.4-0.3)));
			//text2d(.20,-.24,"code");
		}
		else if(time>=0.4 && time<0.5) { glColor4f(.2,0,.5,1-((time-0.4)/(0.5-0.4))); }
		text2d(.20,-.24,"code & music");
		text2d(.20 + 0.1*((time-0.3)/(0.5-0.3)),-.29,"thygrion");
	}
	if((time >= 0.535) && (time < 0.735))
	{
		if(time>=0.535 && time<0.635) { glColor4f(.2,0,.5,((time-0.535)/(0.635-0.535))); }
		else if(time>=0.635 && time<0.735)
		{
			glColor4f(.2,0,.5,1-((time-0.635)/(0.735-0.635)));
			//text2d(.20,-.24,"code");
		}

		text2d(.20,-.24,"code");

		text2d(.20 + 0.1*((time-0.535)/(0.735-0.535)),-.29,"waffle");
	}
	if ((time>0.4) && (time<0.635))
	{
		glColor4f(.2,0,.5,1);
		//text2d(.20,-.24,"code");
	}

	glDisable(GL_BLEND);
}
