#include "tunnel.h"
#include "../general.h"

void tunnel_init(void)
{
}

static float sync_timer = 0.0f;
void tunnel_run(float time)
{
	glBlendFunc(GL_SRC_ALPHA,GL_ONE);
	glEnable(GL_BLEND);
	glDisable(GL_DEPTH_TEST);
	//glTranslatef(0,0,-3);
	glPointSize((float) getscrw() / 1024.0 * 5.0);

	float angle,x=0,y=0,z=-50,r=time,max=140,eraser=0;

	//for(int i = 0; i < 50; i++)
	{
		z += 0.3;
//glPushMatrix();
		float moot = -time*50;

		glPushMatrix();
		glTranslatef(0,-5,-10);
		glRotatef(90, 1, 0, 0);

//max-max*time
		if (time > 0.8)
		{
			eraser = max*(time-0.8)/0.2;
		}

		if (sound_isSync(LEAD))
		{
			sync_timer = timer_gettime() + 0.9f;
		}
		if (sync_timer > timer_gettime())
		{
			//glPointSize(5.0*((sync_timer-timer_gettime())/0.7f));

			if (time > 0.2f)
				for(int i = 0; i < 50; i+=10)
				{
					glBegin(GL_QUAD_STRIP);
					int j_start = int(max-max*time);
					int j_end = int(max-eraser);
					int color_peek = int(((sync_timer-timer_gettime())/0.9f)*(max-eraser));
					for(int j = int(max-max*time); j < int(max-eraser)-1; j++)
					{
//printf("=> %d\n",int(((sync_timer-timer_gettime())/0.7f)*(max-eraser)));
						if (j < color_peek)
						{
							glColor4f(0.511286, 0.389108, 0.694554, (j-j_start)/(float)(color_peek-j_start)*0.37f);
						}
						else
						{
							glColor4f(0.511286, 0.389108, 0.694554, (1.0f-(j-color_peek)/(float)(j_end-color_peek))*0.37f);
						}

						angle=time*2*M_PI*(j/max);
						glVertex3f(r*sin(angle+moot+i), -5+j*0.1f,-5+r*cos(angle+moot+i));
						glVertex3f(r*sin(angle+moot+i)-0.1, -5+j*0.1f,-5+r*cos(angle+moot+i));
					}
					glEnd();
				}
		}

		glColor3f(0.511286, 0.389108, 0.694554);
		glBegin(GL_POINTS);
		for(int j = int(max-max*time); j < int(max-eraser)-1; j++)
		{
			const float timbaland = ((rand()%2)/10.0)-0.1;
			angle=time*2*M_PI*(j/max);
			glVertex3f(r*sin(angle+moot)+timbaland, -5+j*0.1f,-5+r*cos(angle+moot));
			glVertex3f(r*sin(angle+moot+10)+timbaland, -5+j*0.1f,-5+r*cos(angle+moot+10));
			glVertex3f(r*sin(angle+moot+20)+timbaland, -5+j*0.1f,-5+r*cos(angle+moot+20));
			glVertex3f(r*sin(angle+moot+30)+timbaland, -5+j*0.1f,-5+r*cos(angle+moot+30));
			glVertex3f(r*sin(angle+moot+40)+timbaland, -5+j*0.1f,-5+r*cos(angle+moot+40));
		}
		glEnd();

		glPopMatrix();
//glPopMatrix();
	}


	glDisable(GL_BLEND);
	glEnable(GL_DEPTH_TEST);
}

void tunnel_deinit(void)
{
}
