// Font Stuff
#include <string.h>

#include "font.h"

GLuint fonthandle,fonthandle3d;
#ifdef WIN32
GLYPHMETRICSFLOAT gmf[256];
#else
GLuint poo; //3d font handle
#endif

void initfont(HDC hDC,const char *fname) {
#ifdef WIN32
	fonthandle = glGenLists(96);
	HFONT tfont = CreateFont((int) (getscrw() / 640.0 * 32.0), // Height
	                         0, // Width
	                         0,0,
	                         100, // Font weight (0 - 1000)
	                         false, // italic
	                         false, // underline
	                         false, // strikeout
	                         ANSI_CHARSET,
	                         OUT_TT_PRECIS, // Precision (TrueType in this case)
	                         CLIP_DEFAULT_PRECIS,
	                         ANTIALIASED_QUALITY,
	                         FF_DONTCARE | DEFAULT_PITCH,
	                         fname); // Font name
	HFONT font = (HFONT)SelectObject(hDC,tfont);
	wglUseFontBitmaps(hDC,32,96,fonthandle);
	/*wglUseFontOutlines( hDC,
	                    32, // Start char
	                    96, // Lists to build
	                    fonthandle, // Handle
	                    0, // Deviation from outlines
	                    0, // Z-thickness
	                    WGL_FONT_POLYGONS, // Use polygons
	                    gmf); // Address of buffer receiving info*/
	SelectObject(hDC,font);
	DeleteObject(tfont);
	fonthandle3d = glGenLists(256);
	HFONT font2 = CreateFont((int) (getscrw() / 640.0 * 32.0), // Height
	                         0, // Width
	                         0,0,
	                         100, // Font weight (0 - 1000)
	                         false, // italic
	                         false, // underline
	                         false, // strikeout
	                         ANSI_CHARSET,
	                         OUT_TT_PRECIS, // Precision (TrueType in this case)
	                         CLIP_DEFAULT_PRECIS,
	                         ANTIALIASED_QUALITY,
	                         FF_DONTCARE | DEFAULT_PITCH,
	                         fname); // Font name
	SelectObject(hDC,font2);
	wglUseFontOutlines( hDC,
	                    0, // Start char
	                    255, // Lists to build
	                    fonthandle3d, // Handle
	                    0, // Deviation from outlines
	                    0, // Z-thickness
	                    WGL_FONT_POLYGONS, // Use polygons
	                    gmf); // Address of buffer receiving info
#else
	Display *dpy;          /* Our current X display */
	XFontStruct *fontInfo; /* Our font info */

	/* Sotrage for 96 characters */
	fonthandle = glGenLists( 96 );

	/* Get our current display long enough to get the fonts */
	dpy = XOpenDisplay( NULL );

	/* Get the font information */
	fontInfo = XLoadQueryFont( dpy, "-adobe-helvetica-medium-r-normal--32-*-*-*-p-*-iso8859-1" );

	/* If the above font didn't exist try one that should */
	if ( fontInfo == NULL )
	{
		fontInfo = XLoadQueryFont( dpy, "fixed" );
		/* If that font doesn't exist, something is wrong */
		if ( fontInfo == NULL )
		{
			fprintf( stderr, "no X font available?\n" );
			exit( 1 );
		}
	}

	/* generate the list */
	glXUseXFont( fontInfo->fid, 32, 96, fonthandle );

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glViewport(0,0,512,512);
	perspective2DBegin(512, 512);
	glColor3f(1,1,1);


	unsigned char pixels[(512*512+512)*4+1];
	for(int i = 0, j = 0; i < 255; i++)
	{
		if (i%10 == 0)
		{
			j++;
		}

		char c[2];
		sprintf(c, "%c", i+32);
		text2d(
			512*((i%10)/10.0f), // + (51 / 2 - (fontInfo->per_char[i].rbearing - fontInfo->per_char[i].lbearing) / 2),
			512*((10-j)/10.0f) + 32/3,
			c
			);
	}

	glReadPixels(0,0,512,512, GL_RGBA, GL_UNSIGNED_BYTE, pixels);

	perspective2DEnd();

	glGenTextures(1, &poo);
	glBindTexture(GL_TEXTURE_2D, poo);
	glTexImage2D(GL_TEXTURE_2D, 0, 4, 512, 512, 0, GL_RGBA, GL_UNSIGNED_BYTE, pixels);

	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);

	glBindTexture(GL_TEXTURE_2D, 0);

	glEnable(GL_TEXTURE_2D);
	int grid = 10;
	int spacing = 5;

	int listSize = grid*grid;
	float calcg = 1/(float)grid;

	fonthandle3d = glGenLists(listSize);
	glBindTexture(GL_TEXTURE_2D, poo);

	for(int i=0,k=0; i<grid; i++)
	{
		float y = (k/(float)grid)/(float)grid;
		for(int j=0; j<grid; j++,k++)
		{
			float x = 1-(j*grid)/(float)(grid*grid);
			glNewList(fonthandle3d+((listSize-1)-k),GL_COMPILE);
			glBegin(GL_QUADS);
			glTexCoord2f(x, y);
			glVertex2f(grid, grid);

			glTexCoord2f(x-calcg, y);
			glVertex2f(0.0f, grid);

			glTexCoord2f(x-calcg, y-calcg);
			glVertex2f(0.0f, 0.0f);

			glTexCoord2f(x, y-calcg);
			glVertex2f(grid, 0.0f);

			glEnd();
			glTranslatef(spacing,0.0f,0.0f);
			glEndList();
		}
	}
	glDisable(GL_TEXTURE_2D);

	glViewport(0,0,1024,768);

	/* Recover some memory */
	XFreeFont( dpy, fontInfo );

	/* close the display now that we're done with it */
	XCloseDisplay( dpy );
#endif
}

void freefont() {
	glDeleteLists(fonthandle,96);
	glDeleteLists(fonthandle3d,256);
}

void text2d(float ox,float oy,const char *txt) {
	glRasterPos2f(ox,oy);
	glPushAttrib(GL_LIST_BIT);
	glListBase(fonthandle - 32);
	glCallLists(strlen(txt),GL_UNSIGNED_BYTE,txt);
	glPopAttrib();
}

void text3d(const char *txt) {
#ifdef WIN32
	glTranslatef(.1,-.3,0);
	glPushAttrib(GL_LIST_BIT);
	glListBase(fonthandle3d);
	glCallLists(strlen(txt),GL_UNSIGNED_BYTE,txt);
	glPopAttrib();
	glTranslatef(-.1,.3,0);
#else
	glEnable(GL_TEXTURE_2D);
	glDisable(GL_DEPTH_TEST);
	glBlendFunc(GL_ONE, GL_DST_ALPHA);
	glEnable(GL_BLEND);
	glPushAttrib(GL_LIST_BIT);

	glScalef(0.2,0.2,0.2);
	char *string = (char*)malloc(strlen(txt));
	strcpy(string, txt);
	for(int i = 0; i < strlen(txt); i++)
	{
		string[i] -= 10;
	}
	glListBase(fonthandle3d-32);
	glBindTexture(GL_TEXTURE_2D, poo);
	glCallLists(strlen(txt), GL_BYTE, string);
	glPopAttrib();
	glDisable(GL_TEXTURE_2D);
	free(string);
	glBlendFunc(GL_SRC_ALPHA,GL_ONE);
#endif
}
