// "Purple"
//  (C) 2007 Youth Uprising

#include "general.h"
#include "player.h"
#include "config.h"

#ifdef DEBUG
bool debugSyncHit = false;
bool debugSyncKEYUP = false;
#endif

HGLRC hRC = NULL;
HDC hDC = NULL;
HWND hWnd = NULL;
HINSTANCE hInstance;

bool keys[256];
bool active = true;

char *apptitle = "\"Purple\" - (C) 2007 Youth Uprising";
char *fontname = "Georgia";

static void drawBorders(float time)
{
	//time += 117.0;
	if(time >= 122.0) return;
	float alpha = 1.0;
	if(time < 4.0) alpha = time * .25;
	if(time >= 118.0) alpha -= (time - 118.0) * .25;
	glDisable(GL_DEPTH_TEST);
	glDepthRange(0.1, 1.0);
	//draw upper and lower screen borders
	glEnable(GL_BLEND);
	glBlendFunc(GL_ONE, GL_SRC_ALPHA);
	perspective2DBegin(640, 480);
	glColor4f(0,0,0,0.35f);

	glBegin(GL_QUADS);

	//lower border
	glVertex2f(0,0);
	glVertex2f(640,0);
	glVertex2f(640,20);
	glVertex2f(0,20);
	//ramp
	glVertex2f(265,20);
	glVertex2f(640,20);
	glVertex2f(640,30);
	glVertex2f(265,30);

	//upper border
	glVertex2f(0,460);
	glVertex2f(640,460);
	glVertex2f(640,480);
	glVertex2f(0,480);
	//ramp
	glVertex2f(0,460);
	glVertex2f(250,460);
	glVertex2f(250,450);
	glVertex2f(0,450);

	glEnd();

	glBegin(GL_TRIANGLES);

	//lower diagonal ramp (15)
	glVertex2f(250,20);
	glVertex2f(265,20);
	glVertex2f(265,30);

	//upper diagonal ramp
	glVertex2f(265,460);
	glVertex2f(250,460);
	glVertex2f(250,450);

	glEnd();

	//glBlendFunc(GL_SRC_COLOR,GL_ONE);
	//glEnable(GL_BLEND);

	alpha *= .5;

	glDisable(GL_BLEND);
	glDepthRange(0.0, 0.9);

	glLineWidth(2.0);
	glColor3f(alpha,alpha,alpha);
	glBegin(GL_LINE_STRIP);
	glVertex2f(0,20);
	glVertex2f(250,20);
	glVertex2f(265,30);
	glVertex2f(640,30);
	glEnd();
	glBegin(GL_LINE_STRIP);
	glVertex2f(0,450);
	glVertex2f(250,450);
	glVertex2f(265,460);
	glVertex2f(640,460);
	glEnd();

	perspective2DEnd();
	glEnable(GL_BLEND);

}

void initdemo() {
	// GL1
	glClearColor(0,0,0,0);
	// General
	initfont(hDC,fontname);
	// GL2
	GLfloat fc[4] = {0,0,0,0}; // Fog color
	glShadeModel(GL_SMOOTH);
	glHint(GL_PERSPECTIVE_CORRECTION_HINT,GL_NICEST);
	glEnable(GL_POINT_SMOOTH);
	glHint(GL_POINT_SMOOTH_HINT,GL_NICEST);
	glEnable(GL_LINE_SMOOTH);
	glHint(GL_LINE_SMOOTH_HINT,GL_NICEST);
	glFogi(GL_FOG_MODE,GL_LINEAR);
	glFogfv(GL_FOG_COLOR,fc);
	glFogf(GL_FOG_DENSITY,.5);
	glHint(GL_FOG_HINT,GL_DONT_CARE);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(45.0,(GLfloat) getscrw() / (GLfloat) getscrh(),1.0,1000.0);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();

	playerInit();
	// Other
	timer_init();
	timer_addtime(playerRewindTime);
	if(getsoundon()) sound_init();
}

int dodemo() {
	float ctime;
	// GL
	glLineWidth(1.0);
	glDepthMask(1);
	glEnable(GL_DEPTH_TEST);
	glDisable(GL_BLEND);
	glDisable(GL_FOG);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	//Timer
	timer_update();
	ctime = timer_gettime();

	glPushMatrix();
	int ret = playerRun();
	glPopMatrix();

	drawBorders(ctime);

	/*glLoadIdentity();
	   glTranslatef(0,0,-5);

	   glColor3f(1,1,1);
	   //glTranslatef(0,0.5,0);
	   glEnable(GL_TEXTURE_2D);
	   //glScalef(0.2,0.2,0.2);
	    glBindTexture(GL_TEXTURE_2D, poo);
	    int grid = 10;
	    int spacing = 10;

	    int listSize = grid*grid;
	    float calcg = 1/(float)grid;

	    for(int i=0,k=0;i<grid;i++)
	    {
	            float y = (k/grid)/(float)grid;
	            for(int j=0;j<grid;j++,k++)
	            {
	                    float x = 1-(j*grid)/(float)(grid*grid);
	                    glBegin(GL_QUADS);
	                    glTexCoord2f(x-calcg, y);
	                    glVertex2f(0.0f, 0.0f);
	                    glTexCoord2f(x, y);
	                    glVertex2f(grid, 0.0f);
	                    glTexCoord2f(x, y-calcg);
	                    glVertex2f(grid, grid);
	                    glTexCoord2f(x-calcg, y-calcg);
	                    glVertex2f(0.0f, grid);
	                    glEnd();
	                    glTranslatef(spacing,0.0f,0.0f);
	                    glEndList();
	            }
	    }
	   glDisable(GL_TEXTURE_2D);*/

//int ret = 1;
	return ret;
}

#ifdef WIN32
LRESULT CALLBACK WndProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam);

GLvoid FreeGL(GLvoid) {
	if(getfullscreen()) {
		ChangeDisplaySettings(NULL,0);
		ShowCursor(true);
	}
	if(hRC) {
		if(!wglMakeCurrent(NULL,NULL)) //MessageBox(NULL,"Releace of DC and RC failed.","BAD!!",MB_OK | MB_ICONINFORMATION);
			if(!wglDeleteContext(hRC)) //MessageBox(NULL,"Releace of rendering context failed.","BAD!!",MB_OK | MB_ICONINFORMATION);
				hRC = NULL;
	}
	if(hDC && !ReleaseDC(hWnd,hDC)) {
		//MessageBox(NULL,"Releace of device context failed.","BAD!!",MB_OK | MB_ICONINFORMATION);
		hDC = NULL;
	}
	if(hWnd && !DestroyWindow(hWnd)) {
		//MessageBox(NULL,"Releace of window failed.","BAD!!",MB_OK | MB_ICONINFORMATION);
		hWnd = NULL;
	}
	if(!UnregisterClass("c",hInstance)) {
		//MessageBox(NULL,"Releace of class failed.","BAD!!",MB_OK | MB_ICONINFORMATION);
		hInstance = NULL;
	}
}

bool CreateGLWindow(char *title,int width,int height,int bits,int full) {
	GLuint pixelformat;
	WNDCLASS wc;
	DWORD dwExStyle;
	DWORD dwStyle;
	RECT windowrect;
	windowrect.left = (long) 0;
	windowrect.right = (long) width;
	windowrect.top = (long) 0;
	windowrect.bottom = (long) height;
	hInstance = GetModuleHandle(NULL);
	wc.style = CS_HREDRAW | CS_VREDRAW | CS_OWNDC;
	wc.lpfnWndProc = (WNDPROC) WndProc;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hInstance = hInstance;
	wc.hIcon = LoadIcon(NULL,IDI_WINLOGO);
	wc.hCursor = LoadCursor(NULL,IDC_ARROW);
	wc.hbrBackground = NULL;
	wc.lpszMenuName = NULL;
	wc.lpszClassName = "c";
	if(!RegisterClass(&wc)) {
		//MessageBox(NULL,"Registration of window class failed.","BAD!!",MB_OK | MB_ICONEXCLAMATION);
		return false;
	}
	if(getfullscreen()) {
		DEVMODE ss;
		memset(&ss,0,sizeof(ss));
		ss.dmSize = sizeof(ss);
		ss.dmPelsWidth = width;
		ss.dmPelsHeight = height;
		ss.dmBitsPerPel = bits;
		ss.dmFields = DM_BITSPERPEL | DM_PELSWIDTH | DM_PELSHEIGHT;
		if(ChangeDisplaySettings(&ss,CDS_FULLSCREEN) != DISP_CHANGE_SUCCESSFUL) {
			MessageBox(NULL,"The requested fullscreen mode is not supported by your hardware.","BAD!!",MB_OK);
			return false;
		}
	}
	if(getfullscreen()) {
		dwExStyle = WS_EX_APPWINDOW;
		dwStyle = WS_POPUP;
		ShowCursor(false);
	} else {
		dwExStyle = WS_EX_APPWINDOW | WS_EX_WINDOWEDGE;
		dwStyle = WS_EX_OVERLAPPEDWINDOW;
	}
	AdjustWindowRectEx(&windowrect,dwStyle,false,dwExStyle);
	if(!(hWnd = CreateWindowEx(dwExStyle,"c",title,WS_CLIPSIBLINGS | WS_CLIPCHILDREN | dwStyle,0,0,windowrect.right - windowrect.left,windowrect.bottom - windowrect.top,NULL,NULL,hInstance,NULL))) {
		FreeGL();
		//MessageBox(NULL,"Creation of window failed.","BAD!!",MB_OK | MB_ICONEXCLAMATION);
		return false;
	}
	PIXELFORMATDESCRIPTOR pfd = {
		sizeof(PIXELFORMATDESCRIPTOR),1,
		PFD_DRAW_TO_WINDOW | PFD_SUPPORT_OPENGL | PFD_DOUBLEBUFFER,
		PFD_TYPE_RGBA,
		bits,
		0,0,0,0,0,0,
		0, // No alpha buffer
		0,
		0, // No accumulation buffer
		0,0,0,0,
		16, // 16-bit z buffer
		0, // No stencil buffer <- Shadows? ;)
		0, // No auxilary buffer
		PFD_MAIN_PLANE,
		0,0,0,0
	};
	hDC = GetDC(hWnd);
	pixelformat = ChoosePixelFormat(hDC,&pfd);
	SetPixelFormat(hDC,pixelformat,&pfd);
	hRC = wglCreateContext(hDC);
	wglMakeCurrent(hDC,hRC);
	ShowWindow(hWnd,SW_SHOW);
	SetForegroundWindow(hWnd);
	SetFocus(hWnd);
	glViewport(0,0,width,height);
	return true;
}

LRESULT CALLBACK WndProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam) {
	switch(uMsg) {
	case WM_ACTIVATE:
		if(!HIWORD(wParam)) {
			active = true;
		} else {
			active = false;
		}
		return 0;
	case WM_SYSCOMMAND:
		switch(wParam) {
		case SC_SCREENSAVE:
		case SC_MONITORPOWER:
			return 0;
		}
		break;
	case WM_CLOSE:
		PostQuitMessage(0);
		return 0;
	case WM_KEYDOWN:
		keys[wParam] = true;
		return 0;
	case WM_KEYUP:
		keys[wParam] = false;
		return 0;
	}
	return DefWindowProc(hWnd,uMsg,wParam,lParam);
}

int WINAPI WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,INT NcMDShow) {
	MSG msg;
	//if(MessageBox(NULL,"Would you like to run in fullscreen mode?","YUP 64k Demosystem",MB_YESNO | MB_ICONQUESTION) == IDNO) fullscreen = false;
	DialogBox(hInstance,MAKEINTRESOURCE(IDD_DIALOG),NULL,(DLGPROC)ConfigProc);
	if(!getdemo()) {
		if(!CreateGLWindow(apptitle,getscrw(),getscrh(),scrb,getfullscreen())) return 0;
		initdemo();
		while(!getdemo()) {
			Sleep(10);
			if(PeekMessage(&msg,NULL,0,0,PM_REMOVE)) {
				if(msg.message == WM_QUIT) {
					enddemo();
				} else {
					TranslateMessage(&msg);
					DispatchMessage(&msg);
				}
			} else {
				if(active) {
					if(keys[VK_ESCAPE]) {
						enddemo();
					} else {
						if (dodemo())
						{
							SwapBuffers(hDC);
						}
						else { break; }
					}
				}
			}
		}

		FreeGL();
		if(getsoundon()) sound_close();
		playerClose();
	}
	return msg.wParam;
}
#else

int main(int argc, char **argv)
{
	SDL_SetVideoMode(1024, 768, 0, SDL_OPENGL|SDL_FULLSCREEN);
	SDL_ShowCursor(0);
	//SDL_SetVideoMode(640, 480, 0, SDL_OPENGL);

	initdemo();

	while(dodemo()) {
		SwapBuffers(hDC);
		SDL_Delay(10);
		SDL_Event event;
		SDL_PollEvent(&event);
		if (event.key.keysym.sym == SDLK_ESCAPE)
		{
			break;
		}
#ifdef DEBUG
		if (event.key.keysym.sym == SDLK_SPACE)
		{

			if ((event.type == SDL_KEYDOWN) && (debugSyncKEYUP == false))
			{
				debugSyncHit = true;
				debugSyncKEYUP = true;
			}
			else if (event.type == SDL_KEYUP)
			{
				debugSyncHit = false;
				debugSyncKEYUP = false;
			}
		}
#endif
	}

	if(getsoundon()) sound_close();
	playerClose();
	SDL_Quit();
	return EXIT_SUCCESS;
}
#endif
