// Primitives

#include "primitives.h"

#include "general.h"

void gridcube(float scale) {
	float f = scale * .5;
	float fx = -f;
	float xi = scale * .0625;//.125;
	for(int i = 0; i < 16; i++) {
		// - x
		glVertex3f(-f,-f,fx);
		glVertex3f(-f, f,fx);
		glVertex3f(-f,fx,-f);
		glVertex3f(-f,fx, f);
		// + x
		glVertex3f( f,-f,fx);
		glVertex3f( f, f,fx);
		glVertex3f( f,fx,-f);
		glVertex3f( f,fx, f);
		// - y
		glVertex3f(-f,-f,fx);
		glVertex3f( f,-f,fx);
		glVertex3f(fx,-f,-f);
		glVertex3f(fx,-f, f);
		// + y
		glVertex3f(-f, f,fx);
		glVertex3f( f, f,fx);
		glVertex3f(fx, f,-f);
		glVertex3f(fx, f, f);
		// - z
		glVertex3f(-f,fx,-f);
		glVertex3f( f,fx,-f);
		glVertex3f(fx,-f,-f);
		glVertex3f(fx, f,-f);
		// + z
		glVertex3f(-f,fx, f);
		glVertex3f( f,fx, f);
		glVertex3f(fx,-f, f);
		glVertex3f(fx, f, f);
		fx += xi;
	}
}

void linering(float ox,float y,float oz,float scale,int verts) {
	float a;
	float x,z,lx,lz;
	for(int i = 0; i <= verts; i++) {
		a = (float) i / (float) verts * 2.0 * 3.141592;
		x = cos(a) * scale + ox;
		z = sin(a) * scale + oz;
		if(i > 0) {
			glVertex3f(x,y,z);
			glVertex3f(lx,y,lz);
		}
		lx = x;
		lz = z;
	}
}
