// Timer

#include "timer.h"

static bool gtimer;
static float stime,ctime,ltime;
static float tps;
static float deltaspeed;

void timer_init() {
#ifdef WIN32
	LONGLONG ticks;
	LONGLONG freq;

	gtimer = true;
	if(!QueryPerformanceFrequency((LARGE_INTEGER*) &freq)) {
		gtimer = false;
		stime = (float) timeGetTime();
	} else {
		QueryPerformanceCounter((LARGE_INTEGER*) &ticks);
		stime = (float) ticks;
		tps = 1.0 / (float) freq;
	}
#else
	stime = (float) SDL_GetTicks()/1000.0f;
#endif
}

void timer_update() {
#ifdef WIN32
	ltime = ctime;
	if(gtimer) {
		LONGLONG ticks;
		QueryPerformanceCounter((LARGE_INTEGER*) &ticks);
		ctime = ((float) ticks - stime) * tps - playerRewindTime;
	} else {
		ctime = (float) timeGetTime() - stime - playerRewindTime;
	}
	deltaspeed = (ctime - ltime);
#else
	ctime = (float) SDL_GetTicks()/1000.0f - stime;
	deltaspeed = (ctime - ltime);
#endif
}
void timer_addtime(float at) {
#ifndef WIN32
	stime += at;
#endif
}
float timer_gettime() {
	return ctime;
}
/*float timer::getms() {
    return ctime * 1000.0;
   }*/
float timer_getds() {
	return deltaspeed;
}
