// Fuzzy

#include "fuzzy.h"

#define fuzzynum 32

#define tentaclenum 32
#define tentaclevnum 8

#define floorsize 16
#define floordim (floorsize * floorsize)

#define maxrings 32

fuzz *fuzzies;

float *floorx;
float *floorz;
float *floorc;

float tcx,tcy,tcz;
float tcxa,tcya,tcza;

const char greets[32][17] = {
	//"Youth Uprising",
	//"Loves:",
	"3SC",
	"Aardbei",
	"ASD",
	"The Black Lotus",
	"Brainstorm",
	"Calodox",
	"Conspiracy",
	"Dark Bit Factory",
	"DeMarche",
	"Exceed",
	"Equinox",
	"Fairlight",
	"Farb-Rausch",
	"Gravity",
	"Haujobb",
	"Kolor",
	"Mandula",
	"MFX",
	"Orion",
	"Pathos",
	"Plastic",
	"Portal Process",
	"Replay",
	"RGBA",
	"S!P",
	"Spinning Kids",
	"Suburban",
	"The Tin Dragons",
	"Titan",
	"TPOLM",
	"Traction",
	"You"
};

void fresetcamera() {
	glLoadIdentity();
	glTranslatef(tcx,tcy,tcz);
	glRotatef(tcxa,1.0,0,0);
	glRotatef(tcya,0,1.0,0);
	glRotatef(tcza,0,0,1.0);
}

fuzz::fuzz() {
	int i;
	tentan = new float[tentaclenum];
	txan = new float[tentaclenum];
	tyan = new float[tentaclenum];
	tzan = new float[tentaclenum];
	pan = randfloat() * 2.0 * 3.141592;
	for(i = 0; i < tentaclenum; i++) {
		tentan[i] = randfloat() * 2.0 * 3.141592;
		txan[i] = randfloat() * 360.0;
		tyan[i] = randfloat() * 360.0;
		tzan[i] = randfloat() * 360.0;
	}
}
fuzz::~fuzz() {
	delete [] tentan;
	delete [] txan;
	delete [] tyan;
	delete [] tzan;
}

void fuzz::draw(float et,int gi) {
	float et2 = et * 1.5;
	if(et2 < 0 || et2 > 15.0) return;
	float alpha = 1.0;
	if(et2 < 1.0) alpha = et2;
	if(et2 > 13.0) alpha -= (et2 - 13.0) * .5;
	float fuzzyan = et * .9;
	float fuzzyan2 = et * 20.0;
	int i,j;
	float an2;
	float x,y,z,lx,ly,lz;
	float l,ll;
	float s,s2;
	float fuzzyx,fuzzyy,fuzzyz;
	fresetcamera();
	fuzzyy = et2 / 15.0 * 9.0;
	s = (fuzzyy * fuzzyy) * .27;
	fuzzyx = cos(pan + fuzzyan) * s;
	fuzzyz = sin(pan + fuzzyan) * s;
	glPushMatrix();
	glTranslatef(fuzzyx,fuzzyy,fuzzyz);
//printf("%f %f %f\n", fuzzyx, fuzzyy, fuzzyz);
	glColor4f(1.0,1.0,1.0,alpha);
	text3d(greets[gi]);
	for(i = 0; i < tentaclenum; i++) {
		an2 = fuzzyan + tentan[i];
		fresetcamera();
		glTranslatef(fuzzyx,fuzzyy,fuzzyz);
		glRotatef(txan[i] + fuzzyan2,1.0,0,0);
		glRotatef(tyan[i] + fuzzyan2,0,1.0,0);
		glRotatef(tzan[i] + fuzzyan2,0,0,1.0);
		glBegin(GL_LINES);
		for(j = 0; j < tentaclevnum; j++) {
			if(j == 0) {
				y = 0;
				x = 0;
				z = 0;
			} else {
				y = (float) j / (float) tentaclevnum;
				x = sin(an2) * y;
				z = cos(an2 * .67) * y;
				l = 1.0 - y;
				s = l;
				s2 = 1.0 - s;
				glColor4f(s * .2 + s2,s2,s * .5 + s2,s * alpha);
				glVertex3f(x,y,z);
				s = ll;
				s2 = 1.0 - s;
				glColor4f(s * .2 + s2,s2,s * .5 + s2,s * alpha);
				glVertex3f(lx,ly,lz);
			}
			lx = x;
			ly = y;
			lz = z;
			ll = l;
			an2 += .6;
		}
		glEnd();
	}

	glPopMatrix();
//glDisable(GL_BLEND);
//shadow
	glTranslatef(fuzzyx,fuzzyy,fuzzyz);
	//glColor4f(0.0,0.0,0.0,0.0);
//    text3d(greets[gi]);
	for(i = 0; i < tentaclenum; i++) {
		an2 = fuzzyan + tentan[i];
		fresetcamera();
		glTranslatef(fuzzyx,fuzzyy,fuzzyz);
		glRotatef(txan[i] + fuzzyan2,1.0,0,0);
		glRotatef(tyan[i] + fuzzyan2,0,1.0,0);
		glRotatef(tzan[i] + fuzzyan2,0,0,1.0);
		glBegin(GL_POINTS);
		for(j = 0; j < tentaclevnum; j++) {
			if(j == 0) {
				y = 0;
				x = 0;
				z = 0;
			} else {
				y = (float) j / (float) tentaclevnum;
				x = sin(an2) * y;
				z = cos(an2 * .67) * y;
				l = 1.0 - y;
				s = l;
				s2 = 1.0 - s;
				z = lz = y = ly = 1.0f;
				glColor4f(s * .2 + s2,s2,s * .5 + s2,s * alpha);
				glVertex3f(x,y,z);

				s = ll;
				s2 = 1.0 - s;
				glColor4f(s * .2 + s2,s2,s * .5 + s2,s * alpha);
				glVertex3f(lx,ly,lz);
			}
			lx = x;
			ly = y;
			lz = z;
			ll = l;
			an2 += .16;
		}
		glEnd();
	}
}

void initfuzzy() {
	int i,x,y;
	fuzzies = new fuzz[fuzzynum];
	floorx = new float[floordim];
	floorz = new float[floordim];
	floorc = new float[floordim];
	srand(0);//setseed(-1);
	int floori = 0;
	float xd,yd,d;
	for(y = 0; y < floorsize; y++) {
		yd = (float) y - ((float) (floorsize - 1) * .5);
		for(x = 0; x < floorsize; x++) {
			xd = (float) x - ((float) (floorsize - 1) * .5);
			d = sqrt(xd * xd + yd * yd) / (float) (floorsize >> 1) * 1.1;
			if(d < 0) d = 0;
			if(d > 1.0) d = 1.0;
			floorx[floori] = xd;
			floorz[floori] = yd;
			floorc[floori] = 1.0 - d;
			floori++;
		}
	}
}

void freefuzzy() {
	delete [] fuzzies;
	delete [] floorx;
	delete [] floorz;
	delete [] floorc;
}

void fuzzy(float time) {
//time = 0.03;
	float et = time * 46.0;//timer_gettime();
	int i,x,y;
	int floori = 0,fi2,fi3,fi4;
	tcy = -6.0;
	tcz = -24.0;
	tcxa = et * .98 - 10.0;
	tcya = et * 1.1 - 30.0;
	tcza = sin(et * .067) * 20.0;
	glBlendFunc(GL_SRC_ALPHA,GL_ONE);//_MINUS_SRC_ALPHA);
	glFogf(GL_FOG_START,1.0);
	glFogf(GL_FOG_END,48.0);//24.0);
	glDisable(GL_DEPTH_TEST);
	glEnable(GL_BLEND);
	glEnable(GL_FOG);
	glLineWidth(2.0);
	fresetcamera();
	float gcs = 1.0;
	if(et < 2.0) gcs = et * .5;
	if(time >= .95) gcs -= (time - .95) * 20.0;
	/*glBegin(GL_LINES);
	   gridcube(32.0);
	   glEnd();*/
	/*glBegin(GL_LINES);
	   for(i = 0;i < maxrings;i++) {
	    float ri = (float) i * .005;
	    float ra = gcs * .6;
	    if(time + ri >= .95) ra -= (time + ri - .95) * 20.0;
	    if(ra > 0) {
	        glColor4f(1.0,1.0,1.0,ra);
	        float an2 = (float) i * .4 + et * .8;
	        float s = (float) (i * i) * .00125;
	        linering(sin(an2) * s,(float) i * .25,cos(an2) * s,s * 4.0,32);
	    }
	   }
	   glEnd();*/
	glPointSize(1.0f);
	glBegin(GL_QUADS);
	float fs = 1.0;// / (float) floorsize;
	float x1,x2,x3,x4;
	float z1,z2,z3,z4;
//there's some fancy bug in some hardware with the floor tiles hence y = 1 :)
	for(y = 1; y < floorsize; y++) {
		for(x = 0; x < floorsize; x++) {
			x1 = floorx[floori];
			x2 = x1 + fs;
			x3 = x2;
			x4 = x1;
			z1 = floorz[floori];
			z2 = z1;
			z3 = z1 + fs;
			z4 = z3;
			fi2 = floori + 1;
			fi3 = fi2 + floorsize;
			fi4 = floori + floorsize;
			glColor4f(floorc[floori],floorc[floori],floorc[floori],gcs);
			glVertex3f(x1,0,z1);
			glColor4f(floorc[fi2],floorc[fi2],floorc[fi2],gcs);
			glVertex3f(x2,0,z2);
			glColor4f(floorc[fi3],floorc[fi3],floorc[fi3],gcs);
			glVertex3f(x3,0,z3);
			glColor4f(floorc[fi4],floorc[fi4],floorc[fi4],gcs);
			glVertex3f(x4,0,z4);
			floori++;
		}
	}
	glEnd();
	for(i = 0; i < fuzzynum; i++) {
		fuzzies[i].draw(et - (float) i - 1.0,i);
	}
}

